#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#define WINDOW_WIDTH  720    //EBhE-
#define WINDOW_HEIGHT 640    //EBhE-
#define GRAPH_LEFT    130    //Oẗ-W
#define GRAPH_RIGHT   630    //Oẗ-EW
#define GRAPH_TOP     30     //Oẗ-W
#define GRAPH_BOTTOM  530    //Oẗ-W
#define MAX_DATA      2500   //f[^-ől
#define MAX_BUFFER    100    //1f[^-ő啶
#define XSCALE        5      //x-lԂɂڐ̐
#define YSCALE        5      //y-lԂɂڐ̐


/***** ֐vg^Cv錾 *****/
LRESULT CALLBACK WndProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam );    //EBhEvV[W[
HWND create_window( HINSTANCE hInstance );                                        //EBhE쐬
BOOL open_file( HWND hwnd, char *filename );                                      //t@CJ_CAO
int  read_main( char *filename, char *xlabel, char *ylabel, double *x, double *y );   //f[^ǂݍ݃C
int  read_label( char *buffer, char *xlabel, char *ylabel );                          //xǂݍ
int  read_data( char *buffer, double *x, double *y, int i );                          //lf[^ǂݍ
void set_global( double *x, double *y, int n );                                       //O[oϐݒ
void convert( double x, double y, int *u, int *v );                                   //Wϊ
void draw_axis( HDC hdc );                                                            //W`
void draw_label( HDC hdc, LOGFONT logfont, char *xlabel, char *ylabel );              //x`
void draw_scale( HDC hdc, LOGFONT logfont );                                          //ڐ`


/***** O[oϐ錾 *****/
double xmin, xmax, ymin, ymax;   //lf[^őlEŏl
double dx, dy;                   //lf[^͈
double cx, cy;                   //WϊW



/***** C֐ *****/
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
  HWND hwnd;
  MSG  msg;
  BOOL ret;

  /*** EBhE쐬 ***/
  hwnd = create_window( hInstance );
  if( hwnd == NULL ){
    MessageBox( NULL, "EBhE쐬Ɏs", NULL, MB_OK );
    return 1;
  }
  ShowWindow( hwnd, nCmdShow );
  UpdateWindow( hwnd );


  /*** bZ[W[v ***/
  while(1){
    ret = GetMessage( &msg, NULL, 0, 0 );   //bZ[W擾
    if( ret == 0 )
      break;
    else if( ret == -1 ){
      MessageBox( NULL, "bZ[W擾Ɏs", NULL, MB_OK );
      break;
    }
    else
      DispatchMessage( &msg );   //EBhEvV[W[փbZ[Wo
  }

  return (int)msg.wParam;
}



/***** EBhEvV[W[ *****/
LRESULT CALLBACK WndProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
  static LOGFONT logfont;
  static char    filename[MAX_PATH];                       //t@C
  static char    xlabel[MAX_BUFFER], ylabel[MAX_BUFFER];   //x
  static double  x[MAX_DATA], y[MAX_DATA];                 //lf[^i[z
  static int     u[MAX_DATA], v[MAX_DATA];                 //Wϊf[^i[z
  static int     n;                                        //lf[^s
  PAINTSTRUCT ps;
  HDC  hdc;
  HPEN hpen;
  int  i;


  switch(msg){

    case WM_CREATE:
      /*** t@CJ_CAO ***/
      if( !open_file( hwnd, filename ) ){
	SendMessage( hwnd, WM_CLOSE, 0, 0 );
	break;
      }
      /*** f[^ǂݍ ***/
      n = read_main( filename, xlabel, ylabel, x, y );
      set_global( x, y, n );
      for( i=0; i<n; i++ ){
	convert( x[i], y[i], &u[i], &v[i] );
      }
      /*** tHgݒ ***/
      ZeroMemory( &logfont, sizeof(logfont) );
      logfont.lfCharSet = SHIFTJIS_CHARSET;
      strcpy( logfont.lfFaceName, "CI" );
      break;


    case WM_PAINT:
      hdc = BeginPaint( hwnd, &ps );
      /*** ExEڐ̕` ***/
      draw_axis( hdc );
      draw_label( hdc, logfont, xlabel, ylabel );
      draw_scale( hdc, logfont );
      /*** Ot` ***/
      hpen = CreatePen( PS_SOLID, 2, RGB(0,0,0) );
      SelectObject( hdc, hpen );
      MoveToEx( hdc, u[0], v[0], NULL );
      for( i=1; i<n; i++ )
	LineTo( hdc, u[i], v[i] );
      DeleteObject( hpen );
      EndPaint( hwnd, &ps );
      break;


    case WM_DESTROY:
      PostQuitMessage(0);
      break;


    default:
      return DefWindowProc( hwnd, msg, wParam, lParam );
      break;
  }

  return 0;
}



/***** EBhE쐬 *****/
HWND create_window( HINSTANCE hInstance )
{
  WNDCLASSEX wc;

  /*** EBhENXo^ ***/
  wc.cbSize = sizeof(wc);
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon( NULL, IDI_APPLICATION );
  wc.hCursor = LoadCursor( NULL, IDC_IBEAM );
  wc.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
  wc.lpszMenuName = NULL;
  wc.lpszClassName = "Graph";
  wc.hIconSm = NULL;

  if( !RegisterClassEx(&wc) )
    return NULL;


  /*** EBhE쐬 ***/
  return CreateWindow(
	   wc.lpszClassName,               //EBhENX
	   "Graph",                        //EBhE
	   WS_OVERLAPPEDWINDOW,            //EBhEX^C
	   CW_USEDEFAULT, CW_USEDEFAULT,   //EBhËʒu
	   WINDOW_WIDTH, WINDOW_HEIGHT,    //EBhE̕E
	   NULL,                           //eEBhE܂̓I[i[EBhẼnh
	   NULL,                           //j[nh܂͎qEBhEID
	   hInstance,                      //AvP[VCX^X̃nh
	   NULL                            //EBhE쐬f[^
	 );
}



/***** t@CJ_CAO *****/
BOOL open_file( HWND hwnd, char *filename )
{
  OPENFILENAME ofn;

  ZeroMemory( &ofn, sizeof(ofn) );
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = hwnd;
  ofn.lpstrFilter = "text(*.txt)\0*.txt\0All files(*.*)\0*.*\0\0";
  ofn.lpstrFile = filename;
  ofn.nMaxFile = MAX_PATH;
  ofn.Flags = OFN_FILEMUSTEXIST;
  ofn.lpstrTitle = "t@CJ";
  ofn.lpstrDefExt = "txt";

  return GetOpenFileName( &ofn );
}



/***** f[^ǂݍ݃C *****/
int read_main( char *filename, char *xlabel, char *ylabel, double *x, double *y )
{
  FILE *fp;
  char buffer[MAX_BUFFER];
  int  i;

  /*** t@CI[v ***/
  fp = fopen( filename, "r" );
  if( fp == NULL ){
    MessageBox( NULL, "t@CI[vG[", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }

  /*** f[^ǂݍ݃[v ***/
  i = 0;
  while(1){
    if( fgets( buffer, sizeof(buffer), fp ) == NULL ){
      if( feof(fp) )
	break;
      else{
	MessageBox( NULL, "t@Cǂݍ݃G[", NULL, MB_OK );
	PostQuitMessage(0);
	break;
      }
    }
    if( buffer[0] != '\n' ){                          //s͓ǂݔ΂
      if( i==0 && ( strchr(buffer,'(') != NULL ) ){   //t@Cŏ㕔Ɏx܂Ăꍇ
	if( !read_label( buffer, xlabel, ylabel ) )   //xǂݍ
	  break;
      }
      else{
	if( read_data( buffer, x, y, i ) ){           //lf[^ǂݍ
	  i++;
	  if( i > MAX_DATA ){
	    MessageBox( NULL, "f[^I[o[", NULL, MB_OK );
	    PostQuitMessage(0);
	    break;
	  }
	}
	else
	  break;
      }
    }
  }


  if( i<=1 ){
    MessageBox( NULL, "f[^s", NULL, MB_OK );
    PostQuitMessage(0);
  }

  fclose(fp);
  return i;
}



/***** xǂݍ *****/
int read_label( char *buffer, char *xlabel, char *ylabel )
{
  char *p;      //bufferɂ錻ݒn킷|C^[
  int  size;    //p̎w當I[܂ł̕
  int  level;   //ĂȂ '(' ̐
  int  i;


  /*** xx ***/
  p = strchr( buffer, '(' );
  size = strlen(p);
  p++;
  level = 1;
  for( i=0; i<size; i++ ){   //ʂׂĕ܂Ń[v
    if( *p == '(' )          //xxŐVۊʂgꂽꍇ
      level++;
    else if( *p == ')' )     //ʂ1ꍇ
      level--;
    if( level == 0 )         //ׂĂ̊ʂĂꍇ
      break;
    xlabel[i] = *p;          //xlabel1
    p++;                     //̕ֈړ
  }
  if( i >= size ){           //ׂĂ̊ʂȂꍇ
    MessageBox( NULL, "sxx", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }


  /*** yx ***/
  p = strchr( p, '(' );
  if( p == NULL ){
    MessageBox( NULL, "x1", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  size = strlen(p);
  p++;
  level = 1;
  for( i=0; i<size; i++ ){   //ʂׂĕ܂Ń[v
    if( *p == '(' )          //yxŐVۊʂgꂽꍇ
      level++;
    else if( *p == ')' )     //ʂ1ꍇ
      level--;
    if( level == 0 )         //ׂĂ̊ʂĂꍇ
      break;
    ylabel[i] = *p;          //ylabel1
    p++;                     //̕ֈړ
  }
  if( i >= size ){           //ׂĂ̊ʂȂꍇ
    MessageBox( NULL, "syx", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }

  return 1;
}



/***** lf[^ǂݍ *****/
int read_data( char *buffer, double *x, double *y, int i )
{
  char *token, *string;

  /*** xWf[^ ***/
  token = strtok( buffer, " ,\t\n" );
  if( token == NULL ){
    MessageBox( NULL, "xWf[^݂Ȃ", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  x[i] = strtod( token, &string );
  if( x[i]==0 && errno==ERANGE ){
    MessageBox( NULL, "xWf[^A_[t[", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  else if( ( x[i]==HUGE_VAL || x[i]==-HUGE_VAL ) && errno==ERANGE ){
    MessageBox( NULL, "xWf[^I[o[t[", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  if( *string != '\0' ){
    MessageBox( NULL, "xWf[^ɐlłȂ", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }

  /*** yWf[^ ***/
  token = strtok( NULL, " ,\t\n" );
  if( token == NULL ){
    MessageBox( NULL, "yWf[^݂Ȃ", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  y[i] = strtod( token, &string );
  if( y[i]==0 && errno==ERANGE ){
    MessageBox( NULL, "yWf[^A_[t[", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  else if( ( y[i]==HUGE_VAL || y[i]==-HUGE_VAL ) && errno==ERANGE ){
    MessageBox( NULL, "yWf[^I[o[t[", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }
  if( *string != '\0' ){
    MessageBox( NULL, "yWf[^ɐlłȂ", NULL, MB_OK );
    PostQuitMessage(0);
    return 0;
  }

  return 1;
}



/***** O[oϐݒ *****/
void set_global( double *x, double *y, int n )
{
  int i;

  xmin = x[0];
  xmax = x[0];
  ymin = y[0];
  ymax = y[0];
  for( i=1; i<n; i++ ){
    if( x[i] < xmin )
      xmin = x[i];
    else if( x[i] >xmax )
      xmax = x[i];
    if( y[i] < ymin )
      ymin = y[i];
    else if( y[i] > ymax )
      ymax = y[i];
  }

  if( xmin==xmax && ymin==ymax ){
    MessageBox( NULL, "f[^͈̓G[", NULL, MB_OK );
    PostQuitMessage(0);
    return;
  }
  else if( xmin == xmax ){                //yɕsȒ̏ꍇ
    if( xmin > 0 ){
      xmin = 0;
      xmax = 2*xmax;
    }
    else if( xmax < 0 ){
      xmin = 2*xmin;
      xmax = 0;
    }
    else{
      xmin = -1;
      xmax = 1;
    }
  }
  else if( ymin == ymax ){                //xɕsȒ̏ꍇ
    if( ymin > 0 ){
      ymin = 0;
      ymax = 2*ymax;
    }
    else if( ymax < 0 ){
      ymin = 2*ymin;
      ymax = 0;
    }
    else{
      ymin = -1;
      ymax = 1;
    }
  }
  else{
    dy = ymax - ymin;
    if( y[0]!=ymin && y[n-1]!=ymin )      //Ot[ȊȌꏊōŏlƂꍇ
      ymin -= 0.2*dy;
    if( y[0]!=ymax && y[n-1]!=ymax )      //Ot[ȊȌꏊōőlƂꍇ
      ymax += 0.2*dy;
  }

  dx = xmax - xmin;
  dy = ymax - ymin;

  cx = ( GRAPH_RIGHT - GRAPH_LEFT )/dx;   //xWϊW
  cy = ( GRAPH_BOTTOM - GRAPH_TOP )/dy;   //yWϊW

  return;
}



/***** Wϊ *****/
void convert( double x, double y, int *u, int *v )
{
  *u = (int)floor( cx*( x - xmin ) + GRAPH_LEFT + 0.5 );     //(x,y)NCAgW(u,v)֕ϊ
  *v = (int)floor( GRAPH_BOTTOM - cy*( y - ymin ) + 0.5 );   //ľܓint^Ƃ

  if( *u < GRAPH_LEFT )
    *u = GRAPH_LEFT;
  else if( *u > GRAPH_RIGHT )
    *u = GRAPH_RIGHT;
  if( *v < GRAPH_TOP )
    *v = GRAPH_TOP;
  else if( *v > GRAPH_BOTTOM )
    *v = GRAPH_BOTTOM;

  return;
}



/***** W` *****/
void draw_axis( HDC hdc )
{
  int u, v;

  Rectangle( hdc, GRAPH_LEFT, GRAPH_TOP, GRAPH_RIGHT+1, GRAPH_BOTTOM+1 );
  if( xmin*xmax<0 && ymin*ymax<0 ){
    convert( 0, 0, &u, &v );
    MoveToEx( hdc, GRAPH_LEFT, v, NULL );
    LineTo( hdc, GRAPH_RIGHT, v );
    MoveToEx( hdc, u, GRAPH_BOTTOM, NULL );
    LineTo( hdc, u, GRAPH_TOP );
  }

  return;
}



/***** x` *****/
void draw_label( HDC hdc, LOGFONT logfont, char *xlabel, char *ylabel )
{
  HFONT hfont;
  RECT  rect;
  SIZE  size;
  int   padding;

  /*** xx ***/
  hfont = CreateFontIndirect( &logfont );
  SelectObject( hdc, hfont );
  SetRect( &rect, GRAPH_LEFT, GRAPH_BOTTOM+36, GRAPH_RIGHT, GRAPH_BOTTOM+63 );
  DrawText( hdc, xlabel, -1, &rect, DT_CENTER | DT_TOP );

  /*** yx ***/
  logfont.lfEscapement = 900;   //ylabel90]
  hfont = CreateFontIndirect( &logfont );
  SelectObject( hdc, hfont );
  GetTextExtentPoint32( hdc, ylabel, strlen(ylabel), &size );   //ylabel̕ƍvZ
  padding = ( GRAPH_BOTTOM - GRAPH_TOP - size.cx )/2;           //yylabelu߂̗]vZ
  SetRect( &rect, GRAPH_LEFT-95, GRAPH_BOTTOM-padding, GRAPH_LEFT-70, GRAPH_TOP+padding );
  DrawText( hdc, ylabel, -1, &rect, DT_LEFT );
  DeleteObject( hfont );

  return;
}



/***** ڐ` *****/
void draw_scale( HDC hdc, LOGFONT logfont )
{
  HFONT  hfont;
  RECT   rect;
  double decimal;   //
  double integer;   //
  double step;      //ڐԊu
  double scale;     //ڐ蒷iW̒ɑ΂鑊Βlj
  int    factor;    //ڐԊǔWi1,2,5̂ꂩj
  int    index;     //ڐw
  int    imin, imax;
  int    i, u, v;
  char   string[10];
  double epsilon = 1e-15;   //Kȏ

  hfont = CreateFontIndirect( &logfont );
  SelectObject( hdc, hfont );


  /*** xڐԊuݒ ***/
  decimal = modf( log10(dx), &integer );
  if( decimal < 0 ){
    integer--;
    decimal++;
  }
  if( decimal < log10(2) ){
    factor = 5;
    index = (int)integer - 1;
  }
  else if( decimal < log10(4) ){
    factor = 1;
    index = (int)integer;
  }
  else{
    factor = 2;
    index = (int)integer;
  }

  step = factor*pow(10,index)/XSCALE;
  if( xmin < 0 )
    imin = (int)ceil( (1+epsilon)*xmin/step );
  else
    imin = (int)ceil( (1-epsilon)*xmin/step );
  if( xmax < 0 )
    imax = (int)floor( (1-epsilon)*xmax/step );
  else
    imax = (int)floor( (1+epsilon)*xmax/step );

  /*** xڐ` ***/
  for( i=imin; i<=imax; i++ ){
    if( xmin*xmax<0 && ymin*ymax<0 )
	scale = 0.01;
    else{
      if( i%XSCALE == 0 )
	scale = 0.02;
      else
	scale = 0.012;
    }
    convert( i*step, ymin+scale*dy, &u, &v );
    MoveToEx( hdc, u, GRAPH_BOTTOM, NULL );
    LineTo( hdc, u, v );
    convert( i*step, ymax-scale*dy, &u, &v );
    MoveToEx( hdc, u, GRAPH_TOP, NULL );
    LineTo( hdc, u, v );
    if( xmin*xmax<0 && ymin*ymax<0 ){
      convert( i*step, 0.5*scale*dy, &u, &v );
      MoveToEx( hdc, u, v, NULL );
      convert( i*step, -0.5*scale*dy, &u, &v );
      LineTo( hdc, u, v+1 );
    }

    /*** xl` ***/
    if( i%XSCALE == 0 ){
      if( i == 0 )
	sprintf( string, "0" );
      else if( index==0 || index==1 || index==2 )
	sprintf( string, "%d", (int)(i*step) );
      else if( index == -1 )
	sprintf( string, "%.1f", i*step );
      else if( index == -2 )
	sprintf( string, "%.2f", i*step );
      else
	sprintf( string, "%d", i*factor/XSCALE );
      SetRect( &rect, u-30, GRAPH_BOTTOM+7, u+30, GRAPH_BOTTOM+32 );
      DrawText( hdc, string, -1, &rect, DT_CENTER | DT_TOP );
    }
  }

  /*** xw` ***/
  if( abs(index) > 2 ){
    SetRect( &rect, GRAPH_RIGHT-12, GRAPH_BOTTOM+36, GRAPH_RIGHT+24, GRAPH_BOTTOM+63 );
    DrawText( hdc, "~10", -1, &rect, DT_LEFT | DT_TOP );
    sprintf( string, "%d", index );
    logfont.lfHeight = 18;   //w̕TCY
    hfont = CreateFontIndirect( &logfont );
    SelectObject( hdc, hfont );
    SetRect( &rect, GRAPH_RIGHT+24, GRAPH_BOTTOM+32, GRAPH_RIGHT+50, GRAPH_BOTTOM+45 );
    DrawText( hdc, string, -1, &rect, DT_LEFT | DT_TOP );
    logfont.lfHeight = 0;
    hfont = CreateFontIndirect( &logfont );
    SelectObject( hdc, hfont );
  }


  /*** yڐԊuݒ ***/
  decimal = modf( log10(dy), &integer );
  if( decimal < 0 ){
    decimal++;
    integer--;
  }
  if( decimal < log10(2) ){
    factor = 5;
    index = (int)integer - 1;
  }
  else if( decimal < log10(4) ){
    factor = 1;
    index = (int)integer;
  }
  else{
    factor = 2;
    index = (int)integer;
  }

  step = factor*pow(10,index)/YSCALE;
  if( ymin < 0 )
    imin = (int)ceil( (1+epsilon)*ymin/step );
  else
    imin = (int)ceil( (1-epsilon)*ymin/step );
  if( ymax < 0 )
    imax = (int)floor( (1-epsilon)*ymax/step );
  else
    imax = (int)floor( (1+epsilon)*ymax/step );

  /*** yڐ` ***/
  for( i=imin; i<=imax; i++ ){
    if( xmin*xmax<0 && ymin*ymax<0 )
	scale = 0.01;
    else{
      if( i%XSCALE == 0 )
	scale = 0.02;
      else
	scale = 0.012;
    }
    convert( xmin+scale*dx, i*step, &u, &v );
    MoveToEx( hdc, GRAPH_LEFT, v, NULL );
    LineTo( hdc, u, v );
    convert( xmax-scale*dx, i*step, &u, &v );
    MoveToEx( hdc, GRAPH_RIGHT, v, NULL );
    LineTo( hdc, u, v );
    if( xmin*xmax<0 && ymin*ymax<0 ){
      convert( 0.5*scale*dx, i*step, &u, &v );
      MoveToEx( hdc, u, v, NULL );
      convert( -0.5*scale*dx, i*step, &u, &v );
      LineTo( hdc, u-1, v );
    }

    /*** yl` ***/
    if( i%YSCALE == 0 ){
      if( i == 0 )
	sprintf( string, "0" );
      else if( index==0 || index==1 || index==2 )
	sprintf( string, "%d", (int)(i*step) );
      else if( index == -1 )
	sprintf( string, "%.1f", i*step );
      else if( index == -2 )
	sprintf( string, "%.2f", i*step );
      else
	sprintf( string, "%d", i*factor/YSCALE );
      SetRect( &rect, GRAPH_LEFT-70, v-12, GRAPH_LEFT-10, v+12  );
      DrawText( hdc, string, -1, &rect, DT_RIGHT | DT_TOP );
    }
  }

  /*** yw` ***/
  if( abs(index) > 2 ){
    SetRect( &rect, GRAPH_LEFT-100, GRAPH_TOP-20, GRAPH_LEFT-64, GRAPH_TOP );
    DrawText( hdc, "~10", -1, &rect, DT_LEFT | DT_TOP );
    sprintf( string, "%d", index );
    logfont.lfHeight = 18;   //w̕TCY
    hfont = CreateFontIndirect( &logfont );
    SelectObject( hdc, hfont );
    SetRect( &rect, GRAPH_LEFT-64, GRAPH_TOP-24, GRAPH_LEFT-38, GRAPH_TOP-11 );
    DrawText( hdc, string, -1, &rect, DT_LEFT | DT_TOP );
    logfont.lfHeight = 0;
    hfont = CreateFontIndirect( &logfont );
    SelectObject( hdc, hfont );
  }

  DeleteObject( hfont );
  return;
}
